// KillSpanLang.cpp

// 04/27/2007 Start writing
// 04/28/2007 Added Warning Messages and Error Checks


#include <stdio.h>
#include <string.h>

#define _WIN32_WINNT 0x0500

#include <windows.h>
#include <conio.h>
#include <direct.h>



#define BUFSIZE 4096

char lineBuf[BUFSIZE+1]={0};


int Inkey(void)
{
	if(kbhit()!=0)
	{
		return getch();
	}
	else
	{
		return 0;
	}
}

void WaitKeyPress(void)
{
	while(Inkey()!=0)
	{
		Sleep(10);  // Avoid 100% CPU usage
	}
	while(Inkey()==0)
	{
		Sleep(10);  // Avoid 100% CPU usage
	}
}

int IsJapanese(void)
{
	char buf[256];
	GetLocaleInfo(LOCALE_SYSTEM_DEFAULT,LOCALE_ILANGUAGE,buf,256);
	if(strncmp(buf,"0411",4)==0)
	{
		return 1;
	}
	else
	{
		return 0;
	}
}

int WarningMessage(void)
{
	if(IsJapanese()!=0)
	{
		printf("̃vÓAMicrosoft FrontPagefɂɕt\n");
		printf("<span lang=\"..\">`</span>Iɏ܂B\n");
		printf("\n");
		printf("łẢߒŗ\zȂ悤ȃ^ÔƁAt@\n");
		printf("CĂ܂\[ł͂܂BȂ̂ŁAKHTML\n");
		printf("t@C̃obNAbvłpB\n");
		printf("\n");
		printf("܂ÃvO𗘗pƂɂāAꑹ\n");
		printf("悤ȏꍇłA҂͐ӔC𕉂܂̂ŁA̓_̏\n");
		printf("pB\n");
		printf("\n");
		printf("̓_ꍇ́AuYvL[AȂ\n");
		printf("ꍇ́AuNvL[ĂB\n");
		printf("\n");
	}
	else
	{
		printf("This program removes <span lang=\"..\"> and </span> tags that are\n");
		printf("automatically inserted by Microsoft FrontPage.  If you are \n");
		printf("maintaining a web site with more than one language, <span lang>\n");
		printf("tags can be a major headache.  In my case, they are.  By dragging\n");
		printf("and dropping HTML files with those annoying tags to this program,\n");
		printf("you can exterminate those annoying tags.\n");
		printf("\n");
		printf("However, if something unexpected happens, there is a slight chance\n");
		printf("that this program destroys your HTML file.  So, please take a\n");
		printf("backup copy of your HTML file before using this program.\n");
		printf("\n");
		printf("Even if you receive any loss or damage from this program, I will\n");
		printf("not take responsibility for the loss or damage.  Do not use this\n");
		printf("program unless you agree with this condition.\n");
		printf("\n");
		printf("If you agree with this condition, press 'Y' key.  Otherwise, press\n");
		printf("'N' key.\n");
		printf("\n");
	}

	printf(">");

	int ky;
	while(1)
	{
		ky=Inkey();
		if(ky=='y' || ky=='Y')
		{
			printf("Y\n\n");
			return 1;
		}
		else if(ky=='n' || ky=='N')
		{
			printf("N\n\n");
			return 0;
		}
	}
}

int CaseInsensitiveStrncmp(const char str[],const char keyword[])
{
	int i;
	for(i=0; str[i]!=0 && keyword[i]!=0; i++)
	{
		char x,y;
		x=str[i];
		y=keyword[i];

		if('a'<=x && x<='z')
		{
			x=x+'A'-'a';
		}
		if('a'<=y && y<='z')
		{
			y=y+'A'-'a';
		}

		if(x!=y)
		{
			return 1;
		}
	}
	return 0;
}

int IsHtmlOrHtm(const char fn[])
{
	int l;
	l=strlen(fn);
	if(l>=4 && (CaseInsensitiveStrncmp(fn+l-4,".htm")==0 || CaseInsensitiveStrncmp(fn+l-5,".html")==0))
	{
		return 1;
	}
	return 0;
}

int RemoveTag(char buf[],int posInLine)
{
	int i,tagEnd;
	for(i=posInLine; buf[i]!=0; i++)
	{
		if(buf[i]&0x80)
		{
			i++;
		}
		else if(buf[i]=='>')
		{
			tagEnd=i+1;
			for(i=0; buf[tagEnd+i]!=0; i++)
			{
				buf[posInLine+i]=buf[tagEnd+i];
			}
			buf[posInLine+i]=0;
			return 0;
		}
	}
	return -1;
}

int KillSpanLangTag(int &occasion,int insideSpanLang,FILE *ifp,FILE *ofp,char lineBuf[],int &posInLine)
{
	int err;
	while(1)
	{
		if(lineBuf[posInLine]==0 || posInLine==BUFSIZE)
		{
			fprintf(ofp,"%s",lineBuf);
			err=ferror(ofp);
			if(err!=0)
			{
				return err;
			}

			if(fgets(lineBuf,BUFSIZE,ifp)==NULL)
			{
				return 0;
			}
			lineBuf[BUFSIZE]=0;
			posInLine=0;
		}
		else
		{
			if(CaseInsensitiveStrncmp(lineBuf+posInLine,"<span lang=")==0)
			{
				if(RemoveTag(lineBuf,posInLine)==0)
				{
					occasion++;
					err=KillSpanLangTag(occasion,1,ifp,ofp,lineBuf,posInLine);
					if(err!=0)
					{
						return err;
					}
				}
				else
				{
					return -1;
				}
			}
			else if(CaseInsensitiveStrncmp(lineBuf+posInLine,"</span")==0)
			{
				if(insideSpanLang==0)
				{
					posInLine+=6;
				}
				else
				{
					RemoveTag(lineBuf,posInLine);
				}
				return 0;
			}
			else if(CaseInsensitiveStrncmp(lineBuf+posInLine,"<span")==0)
			{
				posInLine++;
				err=KillSpanLangTag(occasion,0,ifp,ofp,lineBuf,posInLine);
				if(err!=0)
				{
					return err;
				}
			}
			else
			{
				posInLine++;
			}
		}
	}
}

int ReplaceExtension(char fn[],const char ext[])
{
	int i;
	int lastDot;

	lastDot=-1;
	for(i=0; fn[i]!=0; i++)
	{
		if(fn[i]&0x80)
		{
			i++;
		}
		else if(fn[i]=='.')
		{
			lastDot=i;
		}
	}

	if(lastDot>=0)
	{
		fn[lastDot]=0;
	}

	strcat(fn,ext);

	return 0;
}

const char *GetFilePart(const char fn[])
{
	int i,lastSeparator;

	lastSeparator=0;
	for(i=0; fn[i]!=0; i++)
	{
		if(fn[i]&0x80)
		{
			i++;
		}
		else if(fn[i]==':' || fn[i]=='/' || fn[i]=='\\')
		{
			lastSeparator=i;
		}
	}

	return fn+lastSeparator;
}

int KillSpanLang(const char fn[])
{
	if(IsHtmlOrHtm(fn)==0)
	{
		printf("%s is not a HTML file. Skipping.\n",fn);
		printf("\n\n");
		return -1;
	}


	FILE *ifp,*ofp;
	int posInLine,occasion;
	char ifn[MAX_PATH],ofn[MAX_PATH],bakfn[MAX_PATH];

	lineBuf[BUFSIZE]=0;
	posInLine=0;
	occasion=0;


	strcpy(ifn,fn);
	strcpy(ofn,fn);
	strcpy(bakfn,fn);

	ReplaceExtension(ofn,".tmp");
	ReplaceExtension(bakfn,".bak");

	printf("FILE : %s\n",ifn);


	ifp=fopen(ifn,"r");
	ofp=fopen(ofn,"w");
	if(ifp!=NULL && ofp!=NULL)
	{
		int err;
		err=KillSpanLangTag(occasion,0,ifp,ofp,lineBuf,posInLine);

		fclose(ifp);
		fclose(ofp);

		if(err==0)
		{
			if(occasion>0)
			{
				printf("%d tags have been removed.\n",occasion);

				remove(bakfn);

				rename(ifn,bakfn);
				rename(ofn,ifn);
			}
			else
			{
				printf("No tag has been removed.\n");

				remove(ofn);
			}
		}
		else
		{
			printf("Error %d\n",err);
		}

		printf("\n\n");

		return err;
	}

	if(ifp!=NULL)
	{
		fclose(ifp);
	}
	if(ofp!=NULL)
	{
		fclose(ofp);
	}

	printf("Could not open file.\n");
	printf("\n\n");

	return 1;
}

void RunByFileDialog(void)
{
	int result;
	OPENFILENAME para;
	char *fnBuf;
	char curpath[MAX_PATH],pth[MAX_PATH],fil[MAX_PATH];
	const unsigned int bufSize=65536;

	HWND hWnd;
	hWnd=GetConsoleWindow();

	fnBuf=new char [bufSize];

	para.lStructSize=sizeof(OPENFILENAME);
	para.hwndOwner=hWnd;
	para.hInstance=(HINSTANCE)GetModuleHandle(NULL);
	para.lpstrFilter="HTML (*.html, *.htm)\0*.html;*.htm\0\0";
	para.lpstrCustomFilter=NULL;
	para.nFilterIndex=0;

	_getcwd(curpath,MAX_PATH);

	fnBuf[0]=0;
	para.lpstrFile=fnBuf;
	para.lpstrInitialDir=curpath;


	para.nMaxFile=bufSize;
	para.lpstrFileTitle=NULL;
	para.lpstrTitle="<span lang=...> Killer: Select HTML Files";
	para.Flags=OFN_HIDEREADONLY|OFN_ALLOWMULTISELECT|OFN_EXPLORER;
	para.lpstrDefExt="htm";

	result=GetOpenFileName(&para);
	_chdir(curpath);

	if(result!=0)
	{
		printf("Path: %s\n",fnBuf);

		int l;
		l=strlen(fnBuf);
		if(l<bufSize-2)
		{
			if(fnBuf[l]==0 && fnBuf[l+1]==0)
			{
				KillSpanLang(fnBuf);
			}
			else
			{
				int fnPtr;
				const char *path;
				char fn[MAX_PATH];

				path=fnBuf;

				fnPtr=l+1;
				while(fnPtr<bufSize-2 && fnBuf[fnPtr]!=0)
				{
					sprintf(fn,"%s\\%s",path,fnBuf+fnPtr);
					KillSpanLang(fnBuf);

					fnPtr+=strlen(fnBuf+fnPtr)+1;
				}
			}
		}
	}

	delete [] fnBuf;
}



int main(int ac,char *av[])
{
	if(WarningMessage()!=0)
	{
		if(ac>=2)
		{
			int i;
			for(i=1; i<ac; i++)
			{
				KillSpanLang(av[i]);
			}
		}
		else
		{
			RunByFileDialog();;
		}

		if(IsJapanese()!=0)
		{
			printf("L[ƏI܂B\n");
		}
		else
		{
			printf("PRESS KEY TO CLOSE THE WINDOW.\n");
		}
		WaitKeyPress();
	}
	return 0;
}
